// DlgFog.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "DlgFog.h"
#include "OpenglView.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgFog dialog

#define INDEX_FOG_LINEAIRE				0
#define INDEX_FOG_EXP					1
#define INDEX_FOG_EXP2					2


CDlgFog::CDlgFog(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgFog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgFog)
	FogDensite = 0.0f;
	FogStart = 0.0f;
	FogEnd = 0.0f;
	//}}AFX_DATA_INIT

	pView = NULL;
	pFog = NULL;

}


void CDlgFog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgFog)
	DDX_Control(pDX, IDC_COMBO_TYPE_FOG, Combo);
	DDX_Control(pDX, IDC_SLIDER_FOG_R, SliderFogR);
	DDX_Control(pDX, IDC_SLIDER_FOG_G, SliderFogG);
	DDX_Control(pDX, IDC_SLIDER_FOG_B, SliderFogB);
	DDX_Control(pDX, IDC_SLIDER_FOG_ALPHA, SliderFogAlpha);
	DDX_Text(pDX, IDC_EDIT_FOG_DENSITE, FogDensite);
	DDX_Text(pDX, IDC_EDIT_FOG_START, FogStart);
	DDX_Text(pDX, IDC_EDIT_FOG_END, FogEnd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgFog, CDialog)
	//{{AFX_MSG_MAP(CDlgFog)
	ON_BN_CLICKED(IDC_APPLIQUER, OnAppliquer)
	ON_CBN_SELCHANGE(IDC_COMBO_TYPE_FOG, OnSelchangeComboTypeFog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgFog message handlers

BOOL CDlgFog::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class
	NMHDR * pNotify;
	pNotify = (NMHDR *) lParam;

	switch (pNotify->idFrom)
	{
	case IDC_SLIDER_FOG_R:
	case IDC_SLIDER_FOG_G:
	case IDC_SLIDER_FOG_B:
	case IDC_SLIDER_FOG_ALPHA:
		SetRgbFog ();
		break;
	}
	
	return CDialog::OnNotify(wParam, lParam, pResult);
}

BOOL CDlgFog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	if (!pFog)
	{
		AfxMessageBox ("L'objet fog n'est pas initialis");
		OnCancel ();
		return TRUE;
	}

	// Initialise la bote de dialogue
	InitDlg ();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// Initialise la bote de dialogue
void CDlgFog :: InitDlg ()
{
	int R,G,B,Alpha;


	// Initialise le Range des slider
	SliderFogR.SetRange (0,255,TRUE);
	SliderFogG.SetRange (0,255,TRUE);
	SliderFogB.SetRange (0,255,TRUE);
	SliderFogAlpha.SetRange (0,255,TRUE);


	// Initialise le positionne des Slider
	R		= RgbFloatToInt (pFog->GetFogR ());
	G		= RgbFloatToInt (pFog->GetFogG ());
	B		= RgbFloatToInt (pFog->GetFogB ());
	Alpha	= RgbFloatToInt (pFog->GetFogAlpha ());
	SliderFogR.SetPos (R);
	SliderFogG.SetPos (G);
	SliderFogB.SetPos (B);
	SliderFogAlpha.SetPos (Alpha);

	// Initialise le type de Fog
	SetComboFogType (pFog->GetTypeFog ());

	// Initialise le start et le End du Fog
	FogStart	= pFog->GetFogStart ();
	FogEnd		= pFog->GetFogEnd ();

	// Initialise les donnes du fog
	FogDensite	= float (1/pFog->GetDensity ()); 

	// Transfert des donnes dans les controles
	UpdateData (FALSE);
}


void CDlgFog::SetRgbFog ()
{
	int R,G,B,Alpha;
	R		= SliderFogR.GetPos ();
	G		= SliderFogG.GetPos ();
	B		= SliderFogB.GetPos ();
	Alpha	= SliderFogAlpha.GetPos();

	pFog->SetFogColor (RgbIntToFloat (R),RgbIntToFloat (G),RgbIntToFloat (B),RgbIntToFloat (Alpha));
	RefreshFogView ();
}


float CDlgFog::RgbIntToFloat (int value){
	float ret;
	ret = (float) value / 255.0f;
	return ret;
}

int CDlgFog::RgbFloatToInt (float value){
	int ret;
	ret = (int) (value * 255);
	return ret;
}


// Initialiser les information
void CDlgFog:: SetFog (CFog * pFogInit)
{
	// Initialise le fog
	pFog = pFogInit;
}



void CDlgFog::OnOK() 
{
	// TODO: Add extra validation here
	SetFogObject ();
	RefreshFogView ();
	CDialog::OnOK();
}

// Change les information de fog de la vue.
void CDlgFog::RefreshFogView ()
{
	if (!pView) return;
	pFog->MakeFog ();
	pView->Invalidate (FALSE);
}



void CDlgFog::OnAppliquer() 
{
	// TODO: Add your control notification handler code here
	SetFogObject ();	
	RefreshFogView ();
}

void CDlgFog::OnSelchangeComboTypeFog() 
{
	SetFogObject ();
	RefreshFogView ();
}


// Initialise le type de fog
void CDlgFog:: SetFogType ()
{
	GLint TypeFogInit;
	int TypeIndex;
	TypeIndex = Combo.GetCurSel ();
	if (TypeIndex == CB_ERR) return;

	switch (TypeIndex)
	{
		case INDEX_FOG_LINEAIRE:	TypeFogInit	= GL_LINEAR;break;
		case INDEX_FOG_EXP:			TypeFogInit = GL_EXP;break;
		case INDEX_FOG_EXP2:		TypeFogInit = GL_EXP2;break;
	}

	pFog->SetTypeFog (TypeFogInit);
}

// Initialise le type de fog dans la combo box
void CDlgFog:: SetComboFogType (int TypeFogInit)
{
	int index;
	switch (TypeFogInit)
	{
		case GL_LINEAR:	index = INDEX_FOG_LINEAIRE;break;
		case GL_EXP:	index = INDEX_FOG_EXP;break;
		case GL_EXP2:	index = INDEX_FOG_EXP2;break;
	}

	Combo.SetCurSel (index);
}



// Initialise L'objet Fog
void CDlgFog :: SetFogObject ()
{
	
	// Transfert les donnes de vontrole dans les variables
	UpdateData (TRUE);

	// Initialiser la densit du fog
	pFog->SetDensity ((float) (1/FogDensite));
	
	// Initialise la couleur du fog
	SetRgbFog ();

	// Initialise le type de Fog
	SetFogType ();

	// Initialise le start et le End du Fog
	pFog->SetFogStart (FogStart);
	pFog->SetFogEnd (FogEnd);

}

