// DlgLight.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "DlgLight.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgLight dialog


CDlgLight::CDlgLight(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLight::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLight)
	Shinessint = 0;
	AmbianteAlphaInt = 0;
	AmbianteBint = 0;
	AmbianteGint = 0;
	AmbianteRint = 0;
	DiffuseAlphaInt = 0;
	DiffuseBint = 0;
	DiffuseGint = 0;
	DiffuseRint = 0;
	EmissionAlphaInt = 0;
	EmissionBint = 0;
	EmissionGint = 0;
	EmissionRint = 0;
	SpeculaireAlphaInt = 0;
	SpeculaireBint = 0;
	SpeculaireGint = 0;
	SpeculaireRint = 0;
	//}}AFX_DATA_INIT

	pMat = NULL;
	RgbSliderId = 0;

	pView = NULL;
}


void CDlgLight::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLight)
	DDX_Control(pDX, IDC_SLIDER_SPECULAIRE_R, SliderSpeculaireR);
	DDX_Control(pDX, IDC_SLIDER_SPECULAIRE_G, SliderSpeculaireG);
	DDX_Control(pDX, IDC_SLIDER_SPECULAIRE_B, SliderSpeculaireB);
	DDX_Control(pDX, IDC_SLIDER_SPECULAIRE_ALPHA, SliderSpeculaireAlpha);
	DDX_Control(pDX, IDC_SLIDER_SHINESS, SliderShiness);
	DDX_Control(pDX, IDC_SLIDER_EMISSION_R, SliderEmissionR);
	DDX_Control(pDX, IDC_SLIDER_EMISSION_G, SliderEmissionG);
	DDX_Control(pDX, IDC_SLIDER_EMISSION_B, SliderEmissionB);
	DDX_Control(pDX, IDC_SLIDER_EMISSION_ALPHA, SliderEmissionAlpha);
	DDX_Control(pDX, IDC_SLIDER_DIFFUSE_R, SliderDiffuseR);
	DDX_Control(pDX, IDC_SLIDER_DIFFUSE_G, SliderDiffuseG);
	DDX_Control(pDX, IDC_SLIDER_DIFFUSE_B, SliderDiffuseB);
	DDX_Control(pDX, IDC_SLIDER_DIFFUSE_ALPHA, SliderDiffuseAlpha);
	DDX_Control(pDX, IDC_SLIDER_AMBIANTE_R, SliderAmbianteR);
	DDX_Control(pDX, IDC_SLIDER_AMBIANTE_G, SliderAmbianteG);
	DDX_Control(pDX, IDC_SLIDER_AMBIANTE_B, SliderAmbianteB);
	DDX_Control(pDX, IDC_SLIDER_AMBIANTE_ALPHA, SliderAmbianteAlpha);
	DDX_Text(pDX, IDC_EDIT_SHINESS, Shinessint);
	DDV_MinMaxInt(pDX, Shinessint, 0, 128);
	DDX_Text(pDX, IDC_EDIT_AMBIANTE_APLHA, AmbianteAlphaInt);
	DDV_MinMaxUInt(pDX, AmbianteAlphaInt, 0, 255);
	DDX_Text(pDX, IDC_EDIT_AMBIANTE_B, AmbianteBint);
	DDV_MinMaxUInt(pDX, AmbianteBint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_AMBIANTE_G, AmbianteGint);
	DDV_MinMaxUInt(pDX, AmbianteGint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_AMBIANTE_R, AmbianteRint);
	DDV_MinMaxUInt(pDX, AmbianteRint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_DIFFUSE_APLHA, DiffuseAlphaInt);
	DDV_MinMaxUInt(pDX, DiffuseAlphaInt, 0, 255);
	DDX_Text(pDX, IDC_EDIT_DIFFUSE_B, DiffuseBint);
	DDV_MinMaxUInt(pDX, DiffuseBint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_DIFFUSE_G, DiffuseGint);
	DDV_MinMaxUInt(pDX, DiffuseGint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_DIFFUSE_R, DiffuseRint);
	DDV_MinMaxUInt(pDX, DiffuseRint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_EMISSION_APLHA, EmissionAlphaInt);
	DDV_MinMaxUInt(pDX, EmissionAlphaInt, 0, 255);
	DDX_Text(pDX, IDC_EDIT_EMISSION_B, EmissionBint);
	DDV_MinMaxUInt(pDX, EmissionBint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_EMISSION_G, EmissionGint);
	DDV_MinMaxUInt(pDX, EmissionGint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_EMISSION_R, EmissionRint);
	DDV_MinMaxUInt(pDX, EmissionRint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_SPECULAIRE_APLHA, SpeculaireAlphaInt);
	DDV_MinMaxUInt(pDX, SpeculaireAlphaInt, 0, 255);
	DDX_Text(pDX, IDC_EDIT_SPECULAIRE_B, SpeculaireBint);
	DDV_MinMaxUInt(pDX, SpeculaireBint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_SPECULAIRE_G, SpeculaireGint);
	DDV_MinMaxUInt(pDX, SpeculaireGint, 0, 255);
	DDX_Text(pDX, IDC_EDIT_SPECULAIRE_R, SpeculaireRint);
	DDV_MinMaxUInt(pDX, SpeculaireRint, 0, 255);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgLight, CDialog)
	//{{AFX_MSG_MAP(CDlgLight)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgLight message handlers

void CDlgLight::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}


BOOL CDlgLight::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	
	NMHDR * pNotify;
	pNotify = (NMHDR *) lParam;

	switch (pNotify->idFrom)
	{

	case IDC_SLIDER_AMBIANTE_R:
	case IDC_SLIDER_AMBIANTE_B:
	case IDC_SLIDER_AMBIANTE_G:
	case IDC_SLIDER_AMBIANTE_ALPHA:
	UpdateRgbAmbiante ();
	break;

	case IDC_SLIDER_DIFFUSE_R:
	case IDC_SLIDER_DIFFUSE_B:
	case IDC_SLIDER_DIFFUSE_G:
	case IDC_SLIDER_DIFFUSE_ALPHA:
	UpdateRgbDiffuse ();
	break;

	case IDC_SLIDER_SPECULAIRE_R:
	case IDC_SLIDER_SPECULAIRE_B:
	case IDC_SLIDER_SPECULAIRE_G:
	case IDC_SLIDER_SPECULAIRE_ALPHA:
	UpdateRgbSpeculaire ();
	break;

	case IDC_SLIDER_EMISSION_R:
	case IDC_SLIDER_EMISSION_B:
	case IDC_SLIDER_EMISSION_G:
	case IDC_SLIDER_EMISSION_ALPHA:
	UpdateRgbEmission ();
	break;
	
	
	case IDC_SLIDER_SHINESS:SetShiness ();break;
	}

	// TODO: Add your specialized code here and/or call the base class
	return CDialog::OnNotify(wParam, lParam, pResult);
}

BOOL CDlgLight::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (!pMat){
		OnCancel ();
		return TRUE;
	}
	
	// TODO: Add extra initialization here
	Init ();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgLight ::  SetShiness (){
	Shinessint = SliderShiness.GetPos ();
	UpdateData (FALSE);
	pMat->Shineness [0] = Shinessint;

	RefreshParent ();
}


void CDlgLight::UpdateRgbAmbiante ()
{
	SetWindowText ("Ambiante");
	AmbianteRint = SliderAmbianteR.GetPos ();
	AmbianteGint = SliderAmbianteG.GetPos ();
	AmbianteBint = SliderAmbianteB.GetPos ();
	AmbianteAlphaInt = SliderAmbianteAlpha.GetPos();

	UpdateData (FALSE);

	pMat->Ambient [0] = RgbIntToFloat (AmbianteRint);
	pMat->Ambient [1] = RgbIntToFloat (AmbianteGint);
	pMat->Ambient [2] = RgbIntToFloat (AmbianteBint);
	pMat->Ambient [3] = RgbIntToFloat (AmbianteAlphaInt);
	RefreshParent ();
}

void CDlgLight::UpdateRgbDiffuse ()
{
	SetWindowText ("Diffuse");
	DiffuseRint = SliderDiffuseR.GetPos ();
	DiffuseGint = SliderDiffuseG.GetPos ();
	DiffuseBint = SliderDiffuseB.GetPos ();
	DiffuseAlphaInt = SliderDiffuseAlpha.GetPos();

	UpdateData (FALSE);

	pMat->Diffuse [0] = RgbIntToFloat (DiffuseRint);
	pMat->Diffuse [1] = RgbIntToFloat (DiffuseGint);
	pMat->Diffuse [2] = RgbIntToFloat (DiffuseBint);
	pMat->Diffuse [3] = RgbIntToFloat (DiffuseAlphaInt);
	RefreshParent ();
}

void CDlgLight::UpdateRgbSpeculaire ()
{
	SetWindowText ("Speculaire");
	SpeculaireRint = SliderSpeculaireR.GetPos ();
	SpeculaireGint = SliderSpeculaireG.GetPos ();
	SpeculaireBint = SliderSpeculaireB.GetPos ();
	SpeculaireAlphaInt = SliderSpeculaireAlpha.GetPos();

	UpdateData (FALSE);

	pMat->Specular [0] = RgbIntToFloat (SpeculaireRint);
	pMat->Specular [1] = RgbIntToFloat (SpeculaireGint);
	pMat->Specular [2] = RgbIntToFloat (SpeculaireBint);
	pMat->Specular [3] = RgbIntToFloat (SpeculaireAlphaInt);
	RefreshParent ();
}

void CDlgLight::UpdateRgbEmission ()
{
	SetWindowText ("Emission");
	EmissionRint = SliderEmissionR.GetPos ();
	EmissionGint = SliderEmissionG.GetPos ();
	EmissionBint = SliderEmissionB.GetPos ();
	EmissionAlphaInt = SliderEmissionAlpha.GetPos();

	UpdateData (FALSE);

	pMat->Emission [0] = RgbIntToFloat (EmissionRint);
	pMat->Emission [1] = RgbIntToFloat (EmissionGint);
	pMat->Emission [2] = RgbIntToFloat (EmissionBint);
	pMat->Emission [3] = RgbIntToFloat (EmissionAlphaInt);

	RefreshParent ();
}

void CDlgLight::RefreshParent ()
{
	if (pView) pView->Invalidate (FALSE);
}


float CDlgLight::RgbIntToFloat (int value){
	float ret;
	ret = (float) value / 255.0f;
	return ret;
}

int CDlgLight::RgbFloatToInt (float value){
	int ret;
	ret = (int) (value * 255);
	return ret;
}



void CDlgLight::Init ()
{
	// Fixer les range de chaque slider
	SliderShiness.SetRange (0,128,TRUE);

	SliderSpeculaireR.SetRange (0,255,TRUE);
	SliderSpeculaireG.SetRange (0,255,TRUE);
	SliderSpeculaireB.SetRange (0,255,TRUE);
	SliderSpeculaireAlpha.SetRange (0,255,TRUE);

	SliderEmissionR.SetRange (0,255,TRUE);
	SliderEmissionG.SetRange (0,255,TRUE);
	SliderEmissionB.SetRange (0,255,TRUE);
	SliderEmissionAlpha.SetRange (0,255,TRUE);
	
	SliderDiffuseR.SetRange (0,255,TRUE);
	SliderDiffuseG.SetRange (0,255,TRUE);
	SliderDiffuseB.SetRange (0,255,TRUE);
	SliderDiffuseAlpha.SetRange (0,255,TRUE);
	
	SliderAmbianteR.SetRange (0,255,TRUE);
	SliderAmbianteG.SetRange (0,255,TRUE);
	SliderAmbianteB.SetRange (0,255,TRUE);
	SliderAmbianteAlpha.SetRange (0,255,TRUE);

	// Initialiser les valeur de chaque slider
	SliderShiness.SetPos ((int) pMat->Shineness [0]);

	SliderSpeculaireR.SetPos (RgbFloatToInt (pMat->Specular [0]));
	SliderSpeculaireG.SetPos (RgbFloatToInt (pMat->Specular [1]));
	SliderSpeculaireB.SetPos (RgbFloatToInt (pMat->Specular [2]));
	SliderSpeculaireAlpha.SetPos (RgbFloatToInt (pMat->Specular [3]));

	SliderEmissionR.SetPos (RgbFloatToInt (pMat->Emission [0]));
	SliderEmissionG.SetPos (RgbFloatToInt (pMat->Emission [1]));
	SliderEmissionB.SetPos (RgbFloatToInt (pMat->Emission [2]));
	SliderEmissionAlpha.SetPos (RgbFloatToInt (pMat->Emission [3]));
	
	SliderDiffuseR.SetPos (RgbFloatToInt (pMat->Diffuse [0]));
	SliderDiffuseG.SetPos (RgbFloatToInt (pMat->Diffuse [1]));
	SliderDiffuseB.SetPos (RgbFloatToInt (pMat->Diffuse [2]));
	SliderDiffuseAlpha.SetPos (RgbFloatToInt (pMat->Diffuse [3]));
	
	SliderAmbianteR.SetPos (RgbFloatToInt (pMat->Ambient [0]));
	SliderAmbianteG.SetPos (RgbFloatToInt (pMat->Ambient [1]));
	SliderAmbianteB.SetPos (RgbFloatToInt (pMat->Ambient [2]));
	SliderAmbianteAlpha.SetPos (RgbFloatToInt (pMat->Ambient [3]));
}
