// MakeTerrainView.h : interface of the CMakeTerrainView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAKETERRAINVIEW_H__087325ED_662A_11D3_B45E_000001200881__INCLUDED_)
#define AFX_MAKETERRAINVIEW_H__087325ED_662A_11D3_B45E_000001200881__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MakeTerrainDoc.h"

class CMakeTerrainView : public CScrollView
{
protected: // create from serialization only

	CMakeTerrainView();
	DECLARE_DYNCREATE(CMakeTerrainView)

	HDC hdc;

	void GetpointByBrush (int x,int y,int &i,int &j);
	BOOL PinceauCercle (int indx,int indy,int i,int j);

// Attributes
public:
	CMakeTerrainDoc* GetDocument();

	int Scale;
	BOOL bShift;
	int brushCote;
	int Rayon;

	void DrawMultiPoint (int indx,int indy,int np);
	void DrawBrush (CPoint pt);
	void DrawArrondissement (int indx,int indy,int rayon);
	void DrawColline (int indx,int indy,int rayon);


	void DrawTerrainHauteur (CDC* pDC);
	void DrawTerrainTexture (CDC* pDC);
	void DrawFacetteTexture (CDC* pDC,int i,int j,int no);
	void DrawMouseFacetteTexture (int ideb,int jdeb);
	void DrawApplatir (int ideb,int jdeb,int npoint);
	void DrawLandscape (CDC * pDC,BOOL bpDCIsCreated = TRUE);
	void ReshapeScrolling ();


	CPoint BrushPt;



// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMakeTerrainView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMakeTerrainView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	afx_msg void OnContextMenu(CWnd*, CPoint point);
	//{{AFX_MSG(CMakeTerrainView)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnReset();
	afx_msg void OnConfigTerrain();
	afx_msg void OnRender();
	afx_msg void OnUpdateRender(CCmdUI* pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnAllInTexture();
	afx_msg void OnUpdateAllInTexture(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MakeTerrainView.cpp
inline CMakeTerrainDoc* CMakeTerrainView::GetDocument()
   { return (CMakeTerrainDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAKETERRAINVIEW_H__087325ED_662A_11D3_B45E_000001200881__INCLUDED_)
