#if !defined(AFX_OPENGLVIEW_H__087325F5_662A_11D3_B45E_000001200881__INCLUDED_)
#define AFX_OPENGLVIEW_H__087325F5_662A_11D3_B45E_000001200881__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OpenglView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COpenglView view
#include "MakeTerrainDoc.h"
#include "ObjetTroisD.h"

#define SHIP_NEXT		TRUE
#define SHIP_PREV		FALSE

#define NBYTE					4
#define NBIT					(8*NBYTE)




class COpenglView : public CView
{
protected:
	COpenglView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(COpenglView)


		// Attributes
public:

	HGLRC		hrc;
    CPalette    m_cPalette;
    CPalette    *m_pOldPalette;
	CRect		m_oldRect;
	float		m_fRadius;
	CClientDC	*m_pDC;

	BOOL bShift;
	BOOL bCtrl;

	// Autre
	CPoint ptMouseMem;
	GLfloat  wAngleY,wAngleX,wAngleZ;
	GLfloat  xt,yt,zt;
	GLfloat Translate;
	int cote;
	BOOL bDraw;
	int NiveauType;
	float NbCaseScale;

	POINTASC_TERRE pCam;

	// Objet de brouillard
	CFog cFog;

	CAlphaTest cAlpha;
	int SelectedShipIndex;


// Operations
public:
	CMakeTerrainDoc* GetDocument();
	void InitGl();
	BOOL bSetupPixelFormat();
	void DrawLight ();
	void DrawCurPoint();
	void DrawTriangleVehicule (CShip * pVais);
	void DrawIFacetteTriangle ();
	void DrawTriangle (int no,FACETTE_TERRE * pFace,POINTASC_TERRE * pt1,POINTASC_TERRE * pt2,POINTASC_TERRE * pt3);
	void DrawAllShip ();
	void DrawMissil ();
	void DrawMissilBilboard(CMissile * pMissil);




	// fonction de desin 3D
	void CalcFog (float fog_densityInit,float fog_colorInit [4]);
	void DrawTerrain ();
	void DrawNiveau ();
	void DrawGraduation ();
	void MoveShip(UINT nFlags, CPoint point);

	void Camera (GLfloat oeilx,GLfloat oeily,GLfloat oeilz,GLfloat ciblex,GLfloat cibley,GLfloat ciblez);
	void RotateShip (CShip * pVais,GLfloat incx,GLfloat incy,GLfloat incz);
	void TranslateObjet (CShip * pVais);
	BOOL SetShipY (CShip * pVais);
	void DrawSpheriqueWorld ();
	void GetSelectedShip (BOOL bSens);
	void DrawSky();
	void NewMissil ();
	void SetShipOnLandscape ();
	void SetAllShipOnLandscape ();
	void ResetView ();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COpenglView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~COpenglView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	afx_msg void OnContextMenu(CWnd*, CPoint point);
	//{{AFX_MSG(COpenglView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnNiveauGrille();
	afx_msg void OnNiveauPlan();
	afx_msg void OnNiveauSquare();
	afx_msg void OnConfigTerrain();
	afx_msg void OnRender();
	afx_msg void OnUpdateRender(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLumiereRaz();
	afx_msg void OnUpdateCalculPente(CCmdUI* pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#ifndef _DEBUG  // debug version in MakeTerrainView.cpp
inline CMakeTerrainDoc* COpenglView::GetDocument()
   { return (CMakeTerrainDoc*)m_pDocument; }
#endif

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.#ifndef _DEBUG  // debug version in MakeTerrainView.cpp



#endif // !defined(AFX_OPENGLVIEW_H__087325F5_662A_11D3_B45E_000001200881__INCLUDED_)




